package cj.server;

import java.awt.event.KeyEvent;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.*;

public class Request {
    /**
     * 请求
     */
    private InputStream is;//输入流
    private  String requestInfo;//请求字符串 请求方式 请求的路径 参数 协议 协议版本 正文
    private String method;//方式
    private  String url;//
    public String getUrl(){
        return url;
    }
    //输入框的name为key，值为value
    private Map<String , List<String >> parametermapValues;//参数
    private static final String CRLF="\r\n";//换行
    private static final String BLANK=" ";//空格
    //构造方法，初始化属性
    public Request(){
        parametermapValues=new HashMap<String,List<String >>();
        method="";
        url="" ;
        requestInfo="";

    }
    public Request(InputStream is){
        this();//调用本类无参的构造方法
        this.is=is;
        try {
            byte[] buf=new byte[20480];
            int len =this.is.read(buf);
            requestInfo=  new String(buf,0,len);
        } catch (IOException e) {
            return;
        }
        //调用本类中的分解请求信息的方法
this.parseRequestInfo();
    }
    private void parseRequestInfo(){
        String paraString = "";
        //获取第一行
        String firstLine=requestInfo.substring(0,requestInfo.indexOf(CRLF)).trim();//从0开始到第一个换行的位置
        //分解出请求方式
        int index=firstLine.indexOf("/");
      this.method=  firstLine.substring(0,index).trim();
      //分解url,get可能包含参数 post不包含
        String urlSting=firstLine.substring(index,firstLine.indexOf("HTTP/")).trim();
        //判断请求方式
        if ("get".equalsIgnoreCase(this.method)){//包含请求参数
            if (urlSting.contains("?")){
                String [] urlArray=urlSting.split("\\?");
                this.url=urlArray[0];
                paraString=urlArray[1];
            }else {
                this.url=urlSting; }

        }else {
            this.url=urlSting;
            requestInfo.substring(requestInfo.lastIndexOf(CRLF)).trim();
        }
        if (paraString.equals("")){
            return;
        }
        //请求参数
       // System.out.println(paraString);
        this.parseParam(paraString);
    }
    /*public void show(){
        System.out.println(this.url);
        System.out.println(this.method);
    }*/
    private void parseParam(String prarString){
        String [] token=prarString.split("&");
        for (int i=0;i<token.length;i++){
            String keyValues=token[i];
            String[] keyValue=keyValues.split("=");
            if (keyValue.length==1){
                keyValue= Arrays.copyOf(keyValue,2);
                keyValue[1]=null;
            }
            //将表单元素name与name对应的值存储在map中
            String  key=keyValue[0].trim();
            String value=keyValue[1]==null?null:decode(keyValue[1].trim(),"utf-8");
            if (!parametermapValues.containsKey(key)){
                parametermapValues.put(key,new ArrayList<String >());

            }
            List<String > values=parametermapValues.get(key);
            values.add(value)  ;
        }
    }

    //根据表单元素name获取多个值
    private String []getParamterValues(String name){
       List<String > values= parametermapValues.get(name);
        if (values==null){
            return null;

        }else {
            return values.toArray(new String[0]);
        }
    }
  public String getParamter(String name){
        //调用本类中根据name获取多个值得方法
      String [] values=  this.getParamterValues(name);
      if (values==null){
          return null;

      }else {
          return values[0];
      }
    }
//处理中文，因为浏览器对中文进行了编码，需要解码
    private String decode(String value,String code){
        try {
            return URLDecoder.decode(value,code);
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return null;
    }
    public static void main(String[] args) {
        Request req=new Request();
        req.parseParam("username=1704080079&pwd=dddd&hobby=ball&hobby=paint");
        System.out.println(req.parametermapValues);
        String []str=req.getParamterValues("hobby");
        for (String string:str){
            System.out.println(string);
        }
        System.out.println(req.getParamter("pwd"));
    }



}
