package cj.server;

import cj.servlet.Servlet;
import cj.util.IOCloseUtil;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class Server {
    /**
     * 服务器用于启动，和停止服务
     */
    private ServerSocket server;
    private boolean isShutDown=false;//默认没有出错

    public static void main(String[] args) {
       Server server=new Server();
        server.start();
    }
    public void start(){
        this.start(8888);
    }
    public void start(int port){
        try {
            server =new ServerSocket(port);
            this.receive();//调用接收请求信息的方法
        } catch (IOException e) {
            isShutDown=true;
        }

    }

    private void receive() {
        //监听
        try {
            while (!isShutDown) {
                Socket client = server.accept();
//创建线程类的对象
                Dispatcher dis= new Dispatcher(client);
                //创建代理类并启动线程
                new Thread(dis).start();

            }
        } catch (IOException e) {
           this.stop();//关闭服务器
        }
    }

    public void stop(){
        isShutDown=true;
        IOCloseUtil.closeAll(server);
    }
}
