package cj.server;


import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;



import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class WebDom4j {//用于解析xml
    private List<Entity> entityList;//用于存储多个Entity，每个Entity都是servlet-name与servlet-class
    private List<Mapping> mappingList;//用于存储多个Mapping，每一个Mapping都是一个server-name与多个url-pattern

    public List<Entity> getEntityList() {
        return entityList;
    }

    public void setEntityList(List<Entity> entityList) {
        this.entityList = entityList;
    }

    public List<Mapping> getMappingList() {
        return mappingList;
    }

    public void setMappingList(List<Mapping> mappingList) {
        this.mappingList = mappingList;
    }
    //构造方法
    public WebDom4j(){
        entityList=new ArrayList<Entity>();
        mappingList=new ArrayList<Mapping>();
    }
    public Document getDocument(){
        try {
            //创建SAXReader对象
            SAXReader reader=new SAXReader();
            //调用read方法
            return   reader.read(new File("src/cj/WIB_INFO/web.xml"));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
    public void parse(Document doc) {

        Element root = doc.getRootElement();
        //获取servlet子元素
        Iterator<Element> ite;
        for (ite = root.elementIterator("servlet"); ite.hasNext(); ) {
            Element subElement = ite.next();
//创建一个实体类
            Entity ent = new Entity();//储存server-name与server-class
            for (Iterator<Element> subIte = subElement.elementIterator(); subIte.hasNext(); ) {
                Element ele = subIte.next();
                if ("server-name".equals(ele.getName())) {
                    ent.setName(ele.getText());//给实体类中的name赋值
                } else if ("server-class".equals(ele.getName())) {
                    ent.setClazz(ele.getText());

                }
            }
            entityList.add(ent);
        }
        /*for (Entity entity:entityList){

            System.out.println(entity.getName()+"\t"+entity.getClazz());
         */
        for (root.elementIterator("servlet-mapping"); ite.hasNext(); ) {
            Element subEle=ite.next();//得到每一个servlet-mapping
            Mapping map=new Mapping();
            for (Iterator<Element> subIte= subEle.elementIterator();subIte.hasNext();){
                Element ele=subIte.next();
                if ("servlet-name".equals(ele.getName())) {
                    map.setName(ele.getText());//给实体类中的name赋值
                } else if ("url-pattern".equals(ele.getName())) {
                    map.getUrlPattern().add(ele.getText());

                }
            }
            mappingList.add(map);
        }
        for (Mapping m:mappingList){
            System.out.println(m.getName());
            for (String s:m.getUrlPattern()){
                System.out.println(s);
            }
        }

    }
    //用于测试
    public static void main(String[] args) {
        WebDom4j web=new WebDom4j();
        web.parse(web.getDocument());
    }
}

